import java.awt.*;
import java.util.*;
import javax.swing.*;

public class VierGewinntBoard extends Board {
  private int FIELD_SIZE = 40;

  private GameClient owner;
  private String stateStr;
  private char state[][];
  private int selection;
  private char who;

  private final int X_OFFSET = 0;
  private final int Y_OFFSET = 22;

  private ImageIcon red, yellow;

  public VierGewinntBoard(GameClient owner) {
    this.owner = owner;
    stateStr = "";
    state = new char[7][6];
    selection = -1;
    initComponents();
    red = new ImageIcon("connect4/red.gif");
    yellow = new ImageIcon("connect4/yellow.gif");
    who = '_';
  }

  private void initComponents() {
    addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        mouseClicker(evt);
      }
    });
  }

  private void mouseClicker(java.awt.event.MouseEvent evt) {
    selection = (evt.getX() - X_OFFSET) / FIELD_SIZE;
    if ((selection < 0) || (selection > 6))
      return;
    owner.setMove("" + (char)('0' + selection));
    repaint(0, 0, 280, FIELD_SIZE);
  }

  private void drawArrow(int x, int y, Graphics g) {
    int xP[] = new int[3];
    int yP[] = new int[3];
    g.fillRect(x - 5, y, 10, 12);
    xP[0] = x - 9;
    xP[2] = x + 9;
    xP[1] = x;
    yP[0] = yP[2] = y + 12;
    yP[1] = y + 19;
    g.fillPolygon(xP, yP, 3);
  }

  public void drawEmptyBoard(Graphics g) {
    int x, y;
    g.setColor(new Color(0, 100, 200));
    g.fillRect(0, Y_OFFSET, 7 * FIELD_SIZE, 6 * FIELD_SIZE);
    for (x = 0; x < 7; x++) {
      g.setColor(Color.black);
      for (y = 0; y < 6; y++)
        g.fillOval(x * FIELD_SIZE + 2, y * FIELD_SIZE + Y_OFFSET + 2, FIELD_SIZE - 4, FIELD_SIZE - 4);
      int midX = x * FIELD_SIZE + FIELD_SIZE / 2;
      g.setColor(Color.lightGray);
      drawArrow(midX, 0, g);
      if (x == selection)
        g.setColor(Color.red);
      else
        g.setColor(Color.black);
      drawArrow(midX + 1, 1, g);
    }
    g.setColor(Color.white);
    if (who == 'w')
      g.drawString("You have the red pieces.", FIELD_SIZE, 274);
    if (who == 'b')
      g.drawString("You have the yellow pieces.", FIELD_SIZE, 274);
  }

  public void paint(Graphics g) {
    int x, y;
    drawEmptyBoard(g);
    for (x = 0; x < 7; x++)
      for (y = 0; y < 6; y++) {
        if (state[x][y] == 'w')
          red.paintIcon(this, g, x * FIELD_SIZE + X_OFFSET, y * FIELD_SIZE + Y_OFFSET);
        if (state[x][y] == 'b')
          yellow.paintIcon(this, g, x * FIELD_SIZE + X_OFFSET, y * FIELD_SIZE + Y_OFFSET);
      }
  }

  public void setBoardState(String aState) {
    stateStr = aState;
    if ((stateStr != null) && (stateStr.length() == 42)) {
      for (int x = 0; x < 7; x++)
        for (int y = 0; y < 6; y++)
          state[x][y] = stateStr.charAt(x + 7 * y);
    }
  }

  public void setTimeOut(long ms) {
  }

  public void setWho(char who) {
    this.who = who;
  }

}

